/*
  boost_xpressive_utility.hpp

  Copyright (C) 2011 Taiji Yamada <taiji@aihara.co.jp>
 */
#ifndef _BOOST_XPRESSIVE_UTILITY_HPP_
#define _BOOST_XPRESSIVE_UTILITY_HPP_
#include <map>
#include <boost/xpressive/xpressive.hpp>

namespace boost { namespace xpressive {

struct string_sregex_map : public std::map<std::string, sregex> {
  sregex &operator[](const std::string &k)
  {
    std::map<std::string, sregex>::iterator i = lower_bound(k);
    if (i == end() || key_comp()(k, (*i).first))
      i = insert(i, value_type(k, sregex(sregex::compile(k))));
    return (*i).second;
  }
  sregex &at(const std::string &k,
	     sregex::flag_type flags = regex_constants::ECMAScript)
  {
    std::map<std::string, sregex>::iterator i = lower_bound(k);
    if (i == end() || key_comp()(k, (*i).first))
      i = insert(i, value_type(k, sregex(sregex::compile(k, flags))));
    return (*i).second;
  }
};

}}

#endif
