/*
  ics-view.cc

  Copyright (C) 2011 Taiji Yamada <taiji@aihara.co.jp>
 */
#include <iostream>
#include <fstream>
#include <string>
#if defined(USE_BOOST_XPRESSIVE)
#include "boost_xpressive_utility.hpp"
using namespace boost::xpressive;
typedef string_sregex_map string_regex_map;
#else
#include "boost_regex_utility.hpp"
#endif
using namespace std;
using namespace boost;

int usage(ostream &os, int argc, char *argv[])
{
  (void)argc;
  os << "usage:\t" << argv[0] << " [--help|-h] [--] -|filename.ics [...]" << endl;
  return os == cerr ? 1 : 0;
}

int main(int argc, char *argv[])
{
  streambuf *cin_rdbuf = cin.rdbuf();
  vector<string> filenames;
  int a;
  for (a=1; a<argc; ++a)
    if (string(argv[a]) == "--" && ++a)
      break;
    else if (string(argv[a]) == "--help" || string(argv[a]) == "-h")
      return usage(cout, argc, argv);
    else
      filenames.push_back(argv[a]);

  if (!filenames.size())
    return usage(cerr, argc, argv);

  string_regex_map regex_map;
#if defined(USE_BOOST_XPRESSIVE)
  regex_map["^begin:"] = xpressive::bos >> xpressive::icase("begin:");
  regex_map["^end:"] = xpressive::bos >> xpressive::icase("end:");
#endif
  for (size_t i=0; i<filenames.size(); ++i) {
    string sp;
    ifstream ifs(filenames[i].c_str());
    cin.rdbuf((filenames[i] != "-") ? ifs.rdbuf() : cin_rdbuf);
    string sb;
    cout << "X-Filename:" << filenames[i] << "\r\n";
    while (getline(cin, sb)) {
      if (sb.size() && sb[sb.size()-1] == '\r') sb.resize(sb.size()-1);
      smatch m;
      if (regex_search(sb, m, regex_map.at("^end:", regex_constants::icase)) &&
	  sp.size())
	sp.resize(sp.size()-1);
      cout << sp << sb << "\r\n";
      if (regex_search(sb, m, regex_map.at("^begin:", regex_constants::icase)))
	sp += "\t";
    }
    if (i != filenames.size()-1) cout << "\r\n";
  }
  return 0;
}
